module ResMonadComb(
    Res
  , run
  , get
  , join
  ) where

import Control.Monad.Reader hiding (fail, join)
import Control.Monad.Trans.Maybe

-- The result monad: a combination of reader monad, list monad and maybe monad.
type Res sigma = ReaderT sigma (MaybeT []) 

-- Elementary operations:

get :: (sigma -> alpha) -> Res sigma alpha
get = reader

join :: alpha -> alpha -> Res sigma alpha
join a b = lift $ lift [a,b]

run :: Res sigma alpha -> sigma -> [Maybe alpha]
run m s = runMaybeT $ runReaderT m s

